﻿
using Microsoft.Azure.Storage.File;

namespace JSViewerCoreMVCApplication2
{
    public class AzureReportsStorage
    {
        private Microsoft.Azure.Storage.File.CloudFileShare _share;
        public AzureReportsStorage(string connString, string shareName)
        {
            var storageAccount = Microsoft.Azure.Storage.CloudStorageAccount.Parse(connString);
            // Create a CloudFileClient object for credentialed access to Azure Files.
            var fileClient = storageAccount.CreateCloudFileClient();
            // Get a reference to the file share we created previously.
            this._share = fileClient.GetShareReference(shareName);
        }
        public GrapeCity.ActiveReports.PageReportModel.Report GetReport(string fileName)
        {
            if (this._share.Exists())
            {
                // Get a reference to the root directory for the share.
                Microsoft.Azure.Storage.File.CloudFileDirectory rootDir = _share.GetRootDirectoryReference();

                // Ensure that the directory exists.
                if (rootDir.Exists())
                {
                    // Get a reference to the file we created previously.
                    Microsoft.Azure.Storage.File.CloudFile file = rootDir.GetFileReference(fileName);

                    // Ensure that the file exists.
                    if (file.Exists())
                    {
                        var ms = new System.IO.MemoryStream();
                        file.DownloadToStream(ms);
                        ms.Position = 0;
                        using (var reader = new System.IO.StreamReader(ms))
                        {
                            var rep =  new GrapeCity.ActiveReports.PageReport(reader);
                            return rep.Report;
                        }
                    }
                    else
                    {
                        return null;
                    }
                }
                else
                {
                    return null;
                }

            }
            else
            {
                return null;
            }
        }
    }

}
